/*
 * JerryCrypt (c) - Keep your fro straight.
 *
 * http://www.afro-productions.com
 *
 * Created by the afro-productions Yellowish Purple Division.
 *
 * This code provides another example but is used as a sort of automatic test
 * system.
 *
 * version information can be found in jcrypt.h
 *
 * 
 */


#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <unistd.h>

#include "jcrypt.h"

#define TESTKEY "bob"
#define TESTSTR "Jefus says hi"
#define EXPECTED_BINKEY "011000100110111101100010"

void fnPut(char *);

int main()
{
	JCRYPT jerrycrypt;
	FILE *ifd, *ofd;

	fprintf(stdout,"Testing JerryCrypt functionality.\n");

	fnPut("JCRYPT_Initalize: ");

	if (!JCRYPT_Initalize(&jerrycrypt))
		fnPut("Failure.\n");
	else
		fnPut("Success.\n");

	fnPut("GenerateKey     : ");

	jerrycrypt.GenerateKey(&jerrycrypt, TESTKEY);

	if (strcmp(jerrycrypt.skey,EXPECTED_BINKEY))
		fnPut("Failure.\n");
	else
		fnPut("Success.\n");

	fnPut("StringEncrypt   : ");

	jerrycrypt.StringEncrypt(&jerrycrypt, TESTSTR, strlen(TESTSTR));

	jerrycrypt.ForceCurrentKeyRestart(&jerrycrypt);

	jerrycrypt.StringDecrypt(&jerrycrypt, jerrycrypt.t_strenc, jerrycrypt.t_strenclen);

	if (strcmp(jerrycrypt.t_strdec, TESTSTR))
	{
		fnPut("Failure.\n");
		fnPut("StringDecrypt   : ");
		fnPut("Failure.\n");
	}
	else
	{
		fnPut("Success.\n");
		fnPut("StringDecrypt   : ");
		fnPut("Success.\n");
	}

	if (((ifd = fopen("atest.c","r")) == NULL) || ((ofd = fopen("atest.enc","w")) == NULL))
		fprintf(stdout,"Error, couldn't open test file(s).  Skipping.\n");
	else
	{
		jerrycrypt.FileEncrypt(&jerrycrypt, ifd,ofd);
	
		fclose(ifd);
		fclose(ofd);

		if (((ifd = fopen("atest.enc","r")) == NULL) || ((ofd = fopen("atest.temp","w")) == NULL))
			fprintf(stdout,"Error, couldn't open test file(s).  Skipping.  (2)\n");
		else
		{
			jerrycrypt.FileDecrypt(&jerrycrypt, ifd,ofd);

			fclose(ifd);
			fclose(ofd);

			if (((ifd = fopen("atest.c","r")) == NULL) || ((ofd = fopen("atest.temp","r")) == NULL))
				fprintf(stdout,"Error, couldn't open test Ifle(s).  Skipping. (3)\n");
			else
			{
				char tbuf1[2] = { 0, 0};
				char tbuf2[2] = { 0, 0};
				int failed = 0;

				while (fread(tbuf1,1,1,ifd))
				{
					if (!fread(tbuf2,1,1,ofd))
					{
						failed = 1;
						break;
					}

					if (tbuf1[0] != tbuf2[0])
					{
						failed = 1;
						break;
					}
				}

				fclose(ifd);
				fclose(ofd);

				if (failed)
				{
					fnPut("FileEncrypt     : Failure.\n");
					fnPut("FileDecrypt     : Failure.\n");
				}
				else
				{
					fnPut("FileEncrypt     : Success.\n");
					fnPut("FileDecrypt     : Success.\n");
				}
			}
		
			remove("atest.enc");	
			remove("atest.temp");
		}
	}

	return 1;
}

void fnPut(char *str)
{
	fprintf(stdout,"%s",str);
	fflush(stdout);
}
