/*
 * JerryCrypt (c) - Keep your fro straight.
 *
 * http://www.afro-productions.com
 * 
 * Created by the afro-productions Yellowish Purple Division.
 *
 * This code provides and example of how to interface with some of the
 * functions in JerryCrypt.
 *
 * version information can be found in jcrypt.h
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <unistd.h>

#include "jcrypt.h"	/* JerryCrypt prototypes, definitions, macros */

int main(int argc, char **argv)
{
	char cbuf1[256], cbuf2[256]; /* just some buffers to use. */
	JCRYPT jc;
	int c, x;

	JCRYPT_Initalize(&jc);	/* don't forget to initalize your struct. */

	memset(cbuf1,0,256);
	memset(cbuf2,0,256);

	fprintf(stdout,"Enter a key: ");
	fflush(stdout);

	fgets(cbuf1,255,stdin);	/* read our key */

	cbuf1[strlen(cbuf1)-1] = 0;	/* chop off the end of line character */

	jc.GenerateKey(&jc, cbuf1); 	/* generate our necesary values */

	jc.PrintKey(&jc, stdout);	/* print the key to verify */

	for (x = 0; x <= L_SHAFTLIKE_PIMP; x++)
	{
		jc.SetLevel(&jc, x); /* Up our level */

		fprintf(stdout,"Round %i (Level = %i)\n",x,x);

		/* Encrypt the string 'This is a test.' */

		jc.StringEncrypt(&jc, "This is a test.", strlen("This is a test."));  

		/* The encrypted value is now stored in jc.t_strenc and the encrypted
		 * length is stored jc.t_strenclen
		 */
	
		fprintf(stdout,"Encrypted: ");
	
		for (c = 0; c < jc.t_strenclen;c++)
			fprintf(stdout,"%c",jc.t_strenc[c]);
	
		fprintf(stdout,"\n");
		fflush(stdout);

		jc.StringDecrypt(&jc, jc.t_strenc, jc.t_strenclen);
	
		/* The decrypted value is now stored in jc.t_strdec and the decrypted
		 * length is stored in jc.t_strdeclen
		 */
	
		fprintf(stdout,"Decrypted: ");
	
		for (c = 0; c < jc.t_strdeclen; c++)
			fprintf(stdout,"%c",jc.t_strdec[c]);

		fprintf(stdout,"\n");
		fflush(stdout);
	}

	return 1;
}
