/* Max Key size. */

#define KEY_SIZE 	2048

/* MAX return string size for string enc/dec funcs */

#define MAX_STR_SIZE	512

/* Encryption levels, add to the confusion. */

#define L_CASUALLY_PIMP   0x00
#define L_PLEASANTLY_PIMP 0x01
#define L_INCREDIBLY_PIMP 0x02
#define L_SHAFTLIKE_PIMP  0x03

#define J_VERSION "JerryCrypt 2.05.00 by afro productions"

typedef struct jcrypt_st {

	char skey[KEY_SIZE];	/* Initalize: 0x00 x KEY_SIZE	*/
	int klen;		/* Initalize: 0			*/
	int spos;		/* Initalize: 0			*/
	int kpos;		/* Initalize: 0 		*/
	int kdiff;		/* Initalize: 1			*/

	int level;		/* Initalize:  L_CASUALLY_PIMP 	*/
	int klevel;		/* Initalize: 0			*/

	int initalized;		/* Initalize: -1 		*/

	int skipped;		/* Initalize: 0			*/

	char t_strenc[MAX_STR_SIZE];
	int t_strenclen;	/* Initalize: 0			*/

	char t_strdec[MAX_STR_SIZE];
	int t_strdeclen;	/* Initalize: 0			*/

	int krestart;		/* Initalize: 1			*/

	void (*GenerateKey) (struct jcrypt_st *, char *str);			/* Initalize: fnGenKey() 	*/
	void (*PrintKey) (struct jcrypt_st *, FILE *ofd);			/* Initalize: fnPrintKey()	*/

	void (*StringEncrypt) (struct jcrypt_st *, char *str, int length);	/* Initalize: fnStrEncrypt() 	*/
	void (*StringDecrypt) (struct jcrypt_st *, char *str, int length);	/* Initalize: fnStrDecrypt()	*/

	void (*FileEncrypt) (struct jcrypt_st *, FILE *ifd, FILE *ofd);		/* Initalize: fnFileEncrypt()	*/
	void (*FileDecrypt) (struct jcrypt_st *, FILE *ifd, FILE *ofd);		/* Initalize: fnFileDecrypt()	*/

	void (*SetLevel) (struct jcrypt_st *, int level);			/* Initalize: fnSetLevel	*/
	int  (*GetLevel) (struct jcrypt_st *);					/* Initalize: fnGetLevel	*/

	void (*DisableCurrentRestart) (struct jcrypt_st *);			/* Initalize: fnDisCurrRestart 	*/
	void (*EnableCurrentRestart) (struct jcrypt_st *);			/* Initalize: fnEnCurrRestart   */ 

	void (*ForceCurrentKeyRestart) (struct jcrypt_st *);			/* Initalize: fnForceKeyRestart */
} JCRYPT;

int JCRYPT_Initalize(struct jcrypt_st *);
void fnGenKey(struct jcrypt_st *, char *str);
void fnPrintKey(struct jcrypt_st *, FILE *ofd);
void fnStrEncrypt(struct jcrypt_st *, char *str, int length);
void fnStrDecrypt(struct jcrypt_st *, char *str, int length);
void fnFileEncrypt(struct jcrypt_st *, FILE *ifd, FILE *ofd);
void fnFileDecrypt(struct jcrypt_st *, FILE *ifd, FILE *ofd);
char *_fnEncryptLetter(struct jcrypt_st *, int letter);
void fnSetLevel(struct jcrypt_st *, int level);
int fnGetLevel(struct jcrypt_st *);
void fnDisCurrRestart(struct jcrypt_st *);
void fnEnCurrRestart(struct jcrypt_st *);
void fnForceKeyRestart(struct jcrypt_st *);
int _fnDecryptLetter(struct jcrypt_st *, int letter);
int _fnCheckInitalized(struct jcrypt_st *);
